; Identifiers

(identifier) @identifier

; Function calls

(decorator) @identifier.decorator

(call
  function: (attribute attribute: (identifier) @identifier.method))

((call
  function: (identifier) @identifier.function)
 (#not-match?
   @identifier.function
   "^(abs|all|any|ascii|bin|bool|breakpoint|bytearray|bytes|callable|chr|classmethod|compile|complex|delattr|dict|dir|divmod|enumerate|eval|exec|filter|float|format|frozenset|getattr|globals|hasattr|hash|help|hex|id|input|int|isinstance|issubclass|iter|len|list|locals|map|max|memoryview|min|next|object|oct|open|ord|pow|print|property|range|repr|reversed|round|set|setattr|slice|sorted|staticmethod|str|sum|super|tuple|type|vars|zip|__import__)$")
)

((call
  function: (identifier) @keyword)
 (#eq? @keyword "super")
)

((call
  function: (identifier) @identifier.function.builtin)
 (#match?
   @identifier.function.builtin
   "^(abs|all|any|ascii|bin|bool|breakpoint|bytearray|bytes|callable|chr|classmethod|compile|complex|delattr|dict|dir|divmod|enumerate|eval|exec|filter|float|format|frozenset|getattr|globals|hasattr|hash|help|hex|id|input|int|isinstance|issubclass|iter|len|list|locals|map|max|memoryview|min|next|object|oct|open|ord|pow|print|property|range|repr|reversed|round|set|setattr|slice|sorted|staticmethod|str|sum|tuple|type|vars|zip|__import__)$"))

; Function definitions

(function_definition
  name: (identifier) @identifier.function)

(parameters
  [
    (identifier) @identifier.argument
    (default_parameter (identifier) @identifier.argument)
    (list_splat_pattern (identifier) @identifier.argument)
    (dictionary_splat_pattern (identifier) @identifier.argument)
    (typed_parameter (identifier) @identifier.argument)
    (typed_default_parameter
      name: (identifier) @identifier.argument)
  ]
 (#not-eq? @identifier.argument "self")
)

; (identifier) @identifier.variable
(attribute attribute: (identifier) @identifier.property)
(type) @identifier.type

; Class definitions
(class_definition
  name: (identifier) @identifier.type.declare)

; Literals

((identifier) @keyword
 (#match? @keyword "^(self|super)$"))

(none) @value.null

[
  (true)
  (false)
] @value.boolean

[
  (integer)
  (float)
] @value.number

(comment) @comment
(string
  "\"" @string.delimiter.left
  "\"" @string.delimiter.right) @string
(escape_sequence) @string.escape

; Documentation comments

(function_definition
  body: (block
    .
    (expression_statement
      (string
        "\"" @comment
        "\"" @comment
      ) @comment)
  )
)
(class_definition
  body: (block
    .
    (expression_statement
      (string
        "\"" @comment
        "\"" @comment
      ) @comment)
  )
)

(interpolation
  "{" @bracket @highlight.reset.start
  "}" @bracket @highlight.reset.end)

[
  "-"
  "-="
  "!="
  "*"
  "**"
  "**="
  "*="
  "/"
  "//"
  "//="
  "/="
  "&"
  "%"
  "%="
  "^"
  "+"
  "->"
  "+="
  "<"
  "<<"
  "<="
  "<>"
  "="
  ":="
  "=="
  ">"
  ">="
  ">>"
  "|"
  "~"
] @operator

[
  "and"
  "in"
  "is"
  "not"
  "or"
  "as"
  "assert"
  "async"
  "await"
  "break"
  "class"
  "continue"
  "def"
  "del"
  "elif"
  "else"
  "except"
  "exec"
  "finally"
  "for"
  "from"
  "global"
  "if"
  "import"
  "lambda"
  "nonlocal"
  "pass"
  "print"
  "raise"
  "return"
  "try"
  "while"
  "with"
  "yield"
  "match"
  "case"
] @keyword

[
  "("
  ")"
  "["
  "]"
  "{"
  "}"
]  @bracket
